"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dynamodb_data_mapper_1 = require("@aws/dynamodb-data-mapper");
const dynamoose_1 = require("dynamoose");
const getKeys_1 = require("./getKeys");
const getTable_1 = require("./getTable");
exports.getModelForClass = ({ dynamoDBClass, modelOptions, schemaOptions, }) => {
    const table = getTable_1.getTable(dynamoDBClass);
    const awsSchema = dynamodb_data_mapper_1.getSchema(new dynamoDBClass());
    const { hash, range } = getKeys_1.getKeys(awsSchema);
    let hashObject = awsSchema[hash];
    let rangeObject = awsSchema[range];
    delete hashObject.keyType;
    delete rangeObject.keyType;
    const schema = new dynamoose_1.Schema(Object.assign(Object.assign({}, awsSchema), { [hash]: Object.assign(Object.assign({}, hashObject), { hashKey: true }), [range]: Object.assign(Object.assign({}, rangeObject), { rangeKey: true }) }), schemaOptions);
    return dynamoose_1.model(table, schema, modelOptions);
};
